%define name pike 
%define release 2
%define pike_version 7.0.71
%define version %{pike_version}

Name: %{name} 
Summary: Pike is a easy OO-scripting language by Fredrik Hubinette 
Version: %{version}
Release: %{release}
Source0: cvs:/pserver:anon@cvs.roxen.com/Pike/7.0/Pike-%{version}.tar.bz2
Source1: install.pike.patch
Group: Development/Pike
URL: http://www.ls-la.net/roxen/
BuildRoot: /var/tmp/%{name}-buildroot
Copyright: GPL
Packager: Wim Bonis <bonis@solution-service.de>
Prefix: /usr
AutoReqProv: no
#The next line is from my redhat6.2:
#Requires: ld-linux.so.2 libcrypt.so.1 libc.so.6 libdl.so.2 libm.so.6 libnsl.so.1 libpthread.so.0 librt.so.1 libgmp.so.2 libICE.so.6 libjpeg.so.62 libGL.so.1 libGLU.so.1 libSM.so.6 libX11.so.6 libXext.so.6 libXi.so.6 libXmu.so.6 libXt.so.6 libgdbm.so.2 libglut.so.3 libpq.so.2.0 libtiff.so.3 libttf.so.2 libz.so.1
# Which makes:
Requires: glibc gmp libjpeg libtiff freetype zlib
Provides: Pike /usr/bin/pike
BuildPrereq: MySQL-devel postgresql-devel libtiff-devel freetype-devel zlib-devel autoconf automake /usr/sbin/chroot

%description
Pike is a GPL'ed OO-programming-language developed by Fredrik Hbinette.

Pike is easily learned, and just as easily used to develop powerful
applications. Pike is designed to be useful and powerful. As the
syntax of Pike is similar to that of C, most programmers will find it
easy to use. As Pike is a high-level, interpreted and modular
object-oriented language, powerful applications can be rapidly
developed. Pike has evolved rather than been designed. The changes to
Pike that have been made have been guided by its users' needs. In
general, the better you get to know Pike, the more you will appreciate
it, from a user's perspective.                                                  

Pike is just as suitable for intricate and large applications as for
creating use-once scripts. When needed, you can also write
Pike modules in C, to gain better performance or access C
libraries. This is transparent to the module's users; the modules
written in C and those written in Pike are accessed in exactly the
same way.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n Pike-%{version}

%build
# Taken from Makefile of Pike-CVS
cd src

./run_autoconfig . 2>&1 | grep -v warning

# Run configure
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
	--without-GTK \
	--prefix=%{prefix}
make MAKE="make -j3"

%install
# 'make install' results in hardcoded paths within master.pike and pike itself
# containing the RPM_BUILD_DIR (/var/roxen-buildroot), which makes pike some-
# what unusable after installing with rpm. To correct this I patched install.
# pike a little bit
cd bin
echo "Patching install.pike"
if [ ! -f install.pike.org ] ; then 
	cp -p install.pike install.pike.org 
	cat %{SOURCE1} | sed -e "s#!PREFIX!#%{prefix}#g" -e "s#!PIKE_VERSION!#%{pike_version}#g" | patch -p0
fi
cd ../src

mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/man/man1
make install prefix=%{buildroot}/%{prefix}

# Remove the wrong dumped objects (they also contain /var/roxen-buildroot)
find $RPM_BUILD_ROOT/%{prefix}/pike/%{pike_version}/lib/modules -name \*.o -exec /bin/rm -f {} \;

# Add the script to dump them at install time
cp -p dumpmodule.pike $RPM_BUILD_ROOT/%{prefix}/pike/%{pike_version}/lib

install -m 644 -s ../man/pike.1 $RPM_BUILD_ROOT/usr/man/man1
install -m 644 -s ../man/hilfe.1 $RPM_BUILD_ROOT/usr/man/man1

# Reset broken pike-Symlink from installation
rm -f $RPM_BUILD_ROOT/%{prefix}/bin/pike
ln -sf %{prefix}/pike/%{pike_version}/bin/pike $RPM_BUILD_ROOT/%{prefix}/bin/pike

# Standard operations taken from the spec-template
if [ -d $RPM_BUILD_ROOT/usr/man ]; then
  find $RPM_BUILD_ROOT/usr/man -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/info ]; then
  find $RPM_BUILD_ROOT/usr/info -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/X11R6/man ]; then
  find $RPM_BUILD_ROOT/usr/X11R6/man -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/lib/perl5/man ]; then
  find $RPM_BUILD_ROOT/usr/lib/perl5/man -type f -exec gzip {} \;
fi

if [ -d $RPM_BUILD_ROOT/usr/bin ]; then
  find $RPM_BUILD_ROOT/usr/bin -type f -exec strip {} \;
fi

# Strip all binaries
if [ -d $RPM_BUILD_ROOT/%{prefix}/pike/*/bin ]; then
  find $RPM_BUILD_ROOT/%{prefix}/pike/*/bin -type f -exec strip {} \;
fi

# Correct #!/usr/local/bin/pike lines to get dependencies working :(
find $RPM_BUILD_ROOT/%{prefix}/pike -type f -exec /usr/bin/perl -p -i -e  \
      's/^\#\!\/usr\/local\/bin\/pike/\#\!\/usr\/bin\/pike/' {} \;


# Generate file-list for the RPM-builder
cd $RPM_BUILD_ROOT
# First, remove TAGS files, otherwise spec-helper will make troubles
find . -type f -name "TAGS" -exec /bin/rm -f '{}' \;

find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
	$RPM_BUILD_DIR/file.list.%{name}

find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
       -e '/\/etc\//s|^|%config |' \
       -e '/\/config\//s|^|%config |' \
       >> $RPM_BUILD_DIR/file.list.%{name}

find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
	$RPM_BUILD_DIR/file.list.%{name}


# Setup a chroot so we can dump the modules

mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/usr/lib
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/usr/share/locale

cp -a /etc/ld.so.cache      $RPM_BUILD_ROOT/etc
cp -a /lib/lib*.so*         $RPM_BUILD_ROOT/lib
cp -a /lib/ld*.so*          $RPM_BUILD_ROOT/lib
cp -a /usr/lib/libgmp.*so*  $RPM_BUILD_ROOT/usr/lib
cp -a /usr/lib/libgdbm.*so*  $RPM_BUILD_ROOT/usr/lib
cp -a /usr/lib/libz.*so*  $RPM_BUILD_ROOT/usr/lib
cp -a /usr/lib/libpq.*so*  $RPM_BUILD_ROOT/usr/lib
cp -a /usr/X11R6/lib/libGL.*so*  $RPM_BUILD_ROOT/usr/X11R6/lib
cp -a /usr/bin/find         $RPM_BUILD_ROOT/usr/bin
cp -a /bin/sh               $RPM_BUILD_ROOT/bin

echo "Dumping Modules, This may take some time"

/usr/sbin/chroot $RPM_BUILD_ROOT /usr/bin/find %{prefix}/pike/%{pike_version}/lib/modules -type f -name \*.pike -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
/usr/sbin/chroot $RPM_BUILD_ROOT /usr/bin/find %{prefix}/pike/%{pike_version}/lib/modules -type f -name \*.pmod -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null

# find .%{prefix}/pike/%{pike_version}/lib/modules -type f -name \*.pike -exec /usr/sbin/chroot $RPM_BUILD_ROOT %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
# find .%{prefix}/pike/%{pike_version}/lib/modules -type f -name \*.pmod -exec /usr/sbin/chroot $RPM_BUILD_ROOT %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
echo "Done Dumping modules!"

# Add them to the List
find .%{prefix}/pike/%{pike_version}/lib/modules -type f -name \*.o | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
       >> $RPM_BUILD_DIR/file.list.%{name}

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files -f ../file.list.%{name}
%defattr(-,root,root,0755)
%doc README ANNOUNCE

## Not needed anymore because we dump them via chroot at install time
## %preun
## if [ $1 -eq 0 ]; then	# We're running "rpm -e"
##    # Delete .o-files generated during "rpm -i"
##    find %{prefix}/pike/%{pike_version}/lib/modules -name \*.o -exec /bin/rm -f {} \;
## fi

## %post
## if [ $1 -eq 1 ]; then	# We're running "rpm -i"
##	# Dump the modules (For speed improvement)
##	echo "Dumping modules, this may take some minutes...."
##	find %{prefix}/pike/%{pike_version}/lib/modules -name \*.pike -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
##	find %{prefix}/pike/%{pike_version}/lib/modules -name \*.pmod -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
##	echo "Done dumping modules."
##fi
##
##if [ $1 -gt 1 ]; then	# We're running "rpm -U"
##	# We should also dump the modules again
##    echo "Dumping modules, this may take some minutes...."
##	find %{prefix}/pike/%{pike_version}/lib/modules -name \*.pike -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null 
##	find %{prefix}/pike/%{pike_version}/lib/modules -name \*.pmod -exec %{prefix}/pike/%{pike_version}/bin/pike %{prefix}/pike/%{pike_version}/lib/dumpmodule.pike {} \; 2>/dev/null
##	echo "Done dumping modules."                                                
##fi

%changelog
* Sun Jul 09 2000 Wim Bonis <bonis@solution-service.de
- "standard" naming schema (Pike-7.0.71)
- Dump the pike modules in a chrooted environment during build time

* Sat Jul 08 2000 Wim Bonis <bonis@solution-service.de
- pike 7.0.71cvs-2:
- make link for pike in /usr/bin
- added man page for pike and hilfe

* Thu Jul 06 2000 Oliver Schade <os@ls-la.net>
- pike-7.0.71cvs-1mdk
- first pike-only rpm with many enhancements by Wim Bonis <bonis@solution-service.de> within the spec-file
